#define IDM_EDITOR      101
#define IDM_EXECUTER    102
#define IDM_OPTIONS     103
#define IDM_EXIT        104

#define IDC_X           500
#define IDC_Y           501
#define IDC_WIDTH       502
#define IDC_HEIGHT      503
#define IDC_STATUS_LINE 505
#define IDC_MENU        506
#define IDC_VER_BAR     507
#define IDC_HOR_BAR     508
#define IDC_FILE_BOX    509



/*****************************************************************************
    Prototypes
******************************************************************************/
BOOL    FAR PASCAL _export DemoForms(HWND,unsigned,WPARAM,LPARAM);
BOOL    FAR PASCAL _export DemoOptions(HWND,unsigned,WPARAM,LPARAM);
BOOL    InitApplication(HANDLE);
BOOL    InitInstance(HANDLE,int);
BOOL    GetNumVal(HWND,int,int *);
int     Bitmap2DIB(void);
int     CallEditor(void);
int     ExtractField(char *,int *,int,char *);
int     FAR PASCAL _export DemoFileField(HWND,unsigned,WPARAM,LPARAM);
int     GetFormFiles(char *);
int     GetFormSelection(char *,int);
int     PASCAL WinMain(HANDLE,HANDLE,LPSTR,int);
int     PrepareFile(void);
int     PrintRecords(struct StrField huge *,int);
int     ReadFields(int);
int     RunReport(void);
int     FAR PASCAL _export UserFieldSelection(HWND,struct StrField huge *,int);
int     FAR PASCAL _export VerifyField(struct StrField huge *,int);
int     FAR PASCAL _export DrawPicture(HDC,int,int,int,RECT far *);
long    FAR PASCAL _export DemoWndProc(HWND,UINT,WPARAM,LPARAM);
void    StringTrim(LPSTR);
void    RightTrim(LPSTR);
void    LeftTrim(LPSTR);
int     OurPrintf(LPSTR,...);

/*****************************************************************************
    Constants used in the demo program.
******************************************************************************/
#define TRUE        1
#define FALSE       0

#define MAX_FORMS   100
#define MAX_FILES   2
#define MAX_FIELDS  15

#define ITEM_WIDTH  40


/******************************************************************************
                      Global Variables for the Demo program
******************************************************************************/
HANDLE hInst,hPrevInst;             // Stores the current and previous instances 

HWND  hDemoWin;                     // demo program window 

struct StrForm FormParm;            // parameter structure used to call form routine 
                                    // see FORM.H file 
struct StrRep  RepParm;             // parameter structure used to call the RepInit routine 

char FormName[MAX_FORMS+2][NAME_WIDTH+2]; // list of avialable form names 
char FormFile[MAX_FORMS+2][13];     // list of avialable form files 
int  TotalForms,NewReport;


BOOL  GetSortField;

struct StrDataFile {                // data file definitions 
       char name[13];               // file names 
       int  TotalFields;
       } DataFile[MAX_FILES];    

struct StrDataField {               // data field definitions 
       char ShortName[15];          // data field name 
       char FullName[35];           // field name with file prefix 
       int  width;                  // display width of the field 
       int  type;                   // field type, see form.h file  
       int  DecPlaces;              // decimal places for numeric/floating fields 
       } DataField[MAX_FILES][MAX_FIELDS];

// fields to display a bitmap

HBITMAP  hLogoBM;                   // customer logo bitmap
HANDLE   hInfo,hImage;              // handle to the device independent bitmap
LPSTR    pImage;                    // pointer to the image data
LPBITMAPINFOHEADER pInfo;           // pointer to the image header data

