unit Dmo_dlp4;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, sysutils, dialogs, dmo_dlp1;

type
  TFieldSel = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ListBox1: TListBox;
    procedure FieldSelShow(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure OkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FieldSel: TFieldSel;

implementation

{$R *.DFM}

procedure TFieldSel.FieldSelShow(Sender: TObject);
var
   i: Integer;
begin
   ListBox1.items.clear;    { reset the contents}

   for i:=0 to DataFile[CurFile].TotalFields -1 do
   begin
     ListBox1.items.Add(DataField[CurFile,i].ShortName);
   end;
end;

procedure TFieldSel.ListBox1DblClick(Sender: TObject);
begin
   CurField:=ListBox1.ItemIndex;  {index of the selected item }
   ModalResult:=mrOk;
   hide;
end;

procedure TFieldSel.OkClick(Sender: TObject);
begin
   ListBox1DblClick(sender);
end;

end.
